
type instruction =
	  Lit of int    (* Push a literal *)
	| Drp           (* Discard a value *)
	| Bin of Ast_types.operators (* Perform arithmetic on top of stack *)
	| Two of int    (* Convert top of stack to two's complement *)
	| Lod of int    (* Fetch global variable *)
	| Str of int    (* Store global variable *)
	| Lfp           (* Load frame pointer from the stack *)
	| Sfp			(* Store frame pointer to the stack *)
	| Jsr of int    (* Call function by absolute address *)
	| Ent           (* Push FP, FP -> SP, SP += i *)
	| Rts of int    (* Restore FP, SP, consume formals, push result *)
	| Beq of int    (* Branch absolute if top-of-stack is zero *)
	| Bne of int    (* Branch absolute if top-of-stack is non-zero *)
	| Bra of int    (* Branch absolute *)
	| Beo of int    (* Branch if end of file *)
	| Hlt           (* Terminate *)
	| Rdb of int    (* Read a number of bytes from the file *)
	| Ldp           (* Load the position in the file onto the stack *)
	| Skp           (* Seek the file to the position on the stack *)

	(* Pseudo bytecode instructions used by compiler *)
	| Label of int  (* Used for branching jumps *)